###################################################
### chunk number 1: t1
###################################################
old.o <- options(prompt=" ", continue=" ", width = 90, digits=4)
old.par <- par(no.readonly=TRUE)


###################################################
### chunk number 2: ni0
###################################################
pkg <- c("maptools","spdep","ade4","Guerry","spacemakeR")
inst.pkg <- row.names(installed.packages())
pkg2inst <- pmatch(pkg,inst.pkg)
if(any(is.na(pkg2inst[1:4])))
  install.packages(pkg[which(is.na(pkg2inst[1:4]))],repos="http://cran.at.r-project.org")
if(is.na(pkg2inst[5]))
  install.packages("spacemakeR", repos="http://R-Forge.R-project.org")

library(maptools)
library(ade4)
library(spdep)
library(spacemakeR)
library(Guerry)


###################################################
### chunk number 3: ni1
###################################################
data(gfrance85)
df <- data.frame(gfrance85)[,7:12]
xy <- coordinates(gfrance85)
dep.names <- data.frame(gfrance85)[,6]
region.names <- data.frame(gfrance85)[,5]
col.region <- colors()[c(149,254,468,552,26)]


###################################################
### chunk number 4: pca
###################################################
pca <- dudi.pca(df,scannf=FALSE,nf=3)


###################################################
### chunk number 5: fig1a
###################################################
scatter(pca)


###################################################
### chunk number 6: fig1aa
###################################################
pca$eig/sum(pca$eig) * 100


###################################################
### chunk number 7: fig1d
###################################################
s.corcircle(pca$co,clabel=0.8)


###################################################
### chunk number 8: fig1b
###################################################
s.class(pca$l1,fac=region.names,col=col.region,cellipse=0,cstar=0,clab=0,cpoint=0)
par(mar=rep(0.1,4))
points(pca$l1,col=col.region[region.names],pch=15) ## pch=20 bug with inkscape
pointLabel(pca$l1[,1:2],as.character(dep.names), cex=0.7)
#legend(-2.5,-1.5,levels(data.frame(gf)$Region),col=1:5,pch=20,cex=0.8,title="Region")
add.scatter.eig(pca$eig,xax=1,yax=2,posi="topleft",ratio=0.25)


###################################################
### chunk number 9: fig1c eval=FALSE
###################################################
## par(mar=rep(0.1,4))
## plot(gfrance85,col=col.region[region.names])
## s.class(xy,region.names,cellipse=0,cstar=0,add.plot=T,cpoint=0,col=col.region)


###################################################
### chunk number 10: fig1cpng
###################################################
png(file="figs/fig-fig1c.png", width=4, height=4, units="in", res=72)
par(mar=rep(0.1,4))
plot(gfrance85,col=col.region[region.names])
s.class(xy,region.names,cellipse=0,cstar=0,add.plot=T,cpoint=0,col=col.region)
dev.off()


###################################################
### chunk number 11: fig2
###################################################
nb <- poly2nb(gfrance85)
lw <- nb2listw(nb, style = "W")


###################################################
### chunk number 12: fig2png
###################################################
png(file="figs/fig-fig2.png", width=7, height=7, units="in", res=72)
par(mar=rep(0.1,4))
plot(gfrance85,col='grey95',border='grey')
plot(lw,coordinates(gfrance85), add=TRUE, pch=20, lwd=2,cex=2)
dev.off()


###################################################
### chunk number 13: moran.coef
###################################################
l1 <- lapply(df,moran.mc,lw,999)
l1


###################################################
### chunk number 14: fig3
###################################################
x <- df[,3]
x.lag <- lag.listw(lw,df[,3])
moran.plot(x,lw)
text(x[5],x.lag[5],dep.names[5],pos=1,cex=0.8)


###################################################
### chunk number 15: fig4 eval=FALSE
###################################################
## mc.pca <- lapply(pca$l1,moran.mc,lw,999)
## par(mar=rep(0.1,4))
## par(mfrow=c(1,2))
## plot(gfrance85,col='grey95',border='grey')
## s.value(xy,pca$li[,1],add.plot=TRUE)
## text(240699,2607012,paste("MC = ", round(mc.pca[[1]]$statistic,3)," (",mc.pca[[1]]$p.value,")",sep=""),cex=0.8)
## plot(gfrance85,col='grey95',border='grey')
## s.value(xy,pca$li[,2],add.plot=TRUE)
## text(240699,2607012,paste("MC = ", round(mc.pca[[2]]$statistic,3)," (",mc.pca[[2]]$p.value,")",sep=""),cex=0.8)


###################################################
### chunk number 16: fig4png
###################################################
png(file="figs/fig-fig4.png", width=6, height=3, units="in", res=72)
mc.pca <- lapply(pca$l1,moran.mc,lw,999)
par(mar=rep(0.1,4))
par(mfrow=c(1,2))
plot(gfrance85,col='grey95',border='grey')
s.value(xy,pca$li[,1],add.plot=TRUE)
text(240699,2607012,paste("MC = ", round(mc.pca[[1]]$statistic,3)," (",mc.pca[[1]]$p.value,")",sep=""),cex=0.8)
plot(gfrance85,col='grey95',border='grey')
s.value(xy,pca$li[,2],add.plot=TRUE)
text(240699,2607012,paste("MC = ", round(mc.pca[[2]]$statistic,3)," (",mc.pca[[2]]$p.value,")",sep=""),cex=0.8)
dev.off()


###################################################
### chunk number 17: bet1
###################################################
bet <- between(pca,region.names,scannf=FALSE,nf=2)


###################################################
### chunk number 18: bet2
###################################################
bet$ratio


###################################################
### chunk number 19: fig5aa
###################################################
plot(bet)


###################################################
### chunk number 20: fig5a
###################################################
barplot(bet$eig)
bet$eig/sum(bet$eig) * 100


###################################################
### chunk number 21: fig5b
###################################################
s.arrow(bet$c1,clabel=0.8)


###################################################
### chunk number 22: fig5c
###################################################
s.class(bet$ls,fac=region.names,col=col.region,cellipse=0,cstar=1,clab=0,cpoint=0)
par(mar=rep(0.1,4))
points(bet$ls,col=col.region[region.names],pch=15) ## pch=20 bug with inkscape
pointLabel(bet$ls[,1:2],as.character(dep.names), cex=0.7,col=col.region[(region.names)])
#legend(-2.5,-1.5,levels(data.frame(gf)$Region),col=1:5,pch=20,cex=0.8,title="Region")
s.class(bet$ls,fac=region.names,col=col.region,cellipse=0,cstar=0,clab=1,cpoint=0,add.plot=T)
add.scatter.eig(bet$eig,xax=1,yax=2,posi="topleft",ratio=0.25)


###################################################
### chunk number 23: fig5dpng
###################################################
png(file="figs/fig-fig5d.png", width=6, height=3, units="in", res=72)
par(mar=rep(0.1,4))
par(mfrow=c(1,2))
plot(gfrance85,col=col.region[region.names],border='transparent')
s.value(xy,bet$ls[,1],add.plot=TRUE)

plot(gfrance85,col=col.region[region.names],border='transparent')
s.value(xy,bet$ls[,2],add.plot=TRUE)
dev.off()


###################################################
### chunk number 24: fig6png
###################################################
png(file = "figs/fig-fig6.png", width=6, height=4, units="in", res=72)
poly.xy <- poly(xy,degree=2)
layout(matrix(c(1,2,0,1,2,4,3,5,4,3,5,0),byrow=T,nrow=4),width=1,height=1/2)
par(mar=rep(0.1,4))
lab <- c(expression(x),expression(x^2),expression(y),expression(xy),expression(y^2))
for(i in 1:ncol(poly.xy)){
  plot(gfrance85,col='grey95',border='grey')
  s.value(xy,poly.xy[,i],add.plot=TRUE,clegend=0)
  text(240699,2607012,lab[i],cex=2)
}
dev.off()


###################################################
### chunk number 25: pcaiv.poly
###################################################
pcaiv.xy <- pcaiv(pca,poly.xy,scannf=FALSE,nf=2)


###################################################
### chunk number 26: fig6c
###################################################
sum(pcaiv.xy$eig)/sum(pca$eig) * 100
pcaiv.xy$eig/sum(pcaiv.xy$eig) * 100


###################################################
### chunk number 27: fig6b
###################################################
plot(pcaiv.xy)


###################################################
### chunk number 28: fig7png
###################################################
png(file = "figs/fig-fig7.png", width=10, height=4, units="in", res=72)
mem<-scores.listw(lw)
par(mfrow=c(2,5),mar=rep(0.1,4))
for(i in 1:10){
  plot(gfrance85,col='grey95', border="grey")
  s.value(xy,mem$vectors[,i],add.plot=TRUE,clegend=0)
  text(270000,2600000,bquote(paste("MC=",.(round(mem$values[i],3)))),cex=1.5)
}
dev.off()


###################################################
### chunk number 29: pcaiv.mem
###################################################
pcaiv.mem <- pcaiv(pca,mem$vectors[,1:10],scannf=FALSE,nf=2)


###################################################
### chunk number 30: fig7b
###################################################
sum(pcaiv.mem$eig)/sum(pca$eig) * 100
pcaiv.mem$eig/sum(pcaiv.mem$eig) * 100


###################################################
### chunk number 31: fig7c
###################################################
plot(pcaiv.mem)


###################################################
### chunk number 32: multispati
###################################################
ms <- multispati(pca,lw,scannf=FALSE)


###################################################
### chunk number 33: fig8a
###################################################
plot(ms)


###################################################
### chunk number 34: fig8b
###################################################
sum.ms <- summary(ms)
sum.ms


###################################################
### chunk number 35: fig8c
###################################################
s.arrow(ms$c1,clabel=0.8)


###################################################
### chunk number 36: fig8d
###################################################
s.match(ms$li,ms$ls, clabel =0,pch=15)
s.match(ms$li[c(10,41,27),],ms$ls[c(10,41,27),],label=dep.names[c(10,41,27)],clabel=0.8,add.plot=TRUE,pch=15)


###################################################
### chunk number 37: fig8epng
###################################################
png(file = "figs/fig-fig8e.png", width=6, height=3, units="in", res=72)
par(mar=rep(0.1,4))
par(mfrow=c(1,2))
plot(gfrance85,,col='grey95',border='grey')
s.value(xy,ms$li[,1],add.plot=TRUE)

plot(gfrance85,,col='grey95',border='grey')
s.value(xy,ms$ls[,1],add.plot=TRUE)
dev.off()


###################################################
### chunk number 38: ccl
###################################################
mat <- matrix(NA,4,4)
mat.names <- c("PCA","BCA","PCAIV-POLY","PCAIV-MEM","MULTISPATI")
colnames(mat) <- mat.names[-5]
rownames(mat) <- mat.names[-1]
test1 <- procuste.randtest(pca$li[,1:2],bet$ls[,1:2])
test2 <- procuste.randtest(pca$li[,1:2],pcaiv.xy$ls[,1:2])
test3 <- procuste.randtest(pca$li[,1:2],pcaiv.mem$ls[,1:2])
test4 <- procuste.randtest(pca$li[,1:2],ms$li[,1:2])

test5 <- procuste.randtest(bet$ls[,1:2],pcaiv.xy$ls[,1:2])
test6 <- procuste.randtest(bet$ls[,1:2],pcaiv.mem$ls[,1:2])
test7 <- procuste.randtest(bet$ls[,1:2],ms$li[,1:2])

test8 <- procuste.randtest(pcaiv.xy$ls[,1:2],pcaiv.mem$ls[,1:2])
test9 <- procuste.randtest(pcaiv.xy$ls[,1:2],ms$li[,1:2])

test10 <- procuste.randtest(pcaiv.mem$ls[,1:2],ms$li[,1:2])

mat[1:4, 1] <- c(test1$obs, test2$obs, test3$obs, test4$obs)
#mat[1,1] <- test1$obs
#mat[2,1] <- test2$obs
#mat[3,1] <- test3$obs
#mat[4,1] <- test4$obs

mat[2:4, 2] <- c(test5$obs, test6$obs, test7$obs)
#mat[2,2] <- test5$obs
#mat[3,2] <- test6$obs
#mat[4,2] <- test7$obs

mat[3:4, 3] <- c(test8$obs, test9$obs)
#mat[3,3] <- test8$obs
#mat[4,3] <- test9$obs

mat[4, 4] <- test10$obs

mat


###################################################
### chunk number 39: t1end
###################################################
options(old.o)
par(old.par)


